function CEV:Init()
	CEV._enabled = true
	CEV.escape_vans = {}
	CEV.escape_vehicles = {}
	CEV.mission_specs = {}
	CEV.vehicle_specs = {}
end

function CEV:GetOption(_optn)
	local optn = CEV.Options:GetValue(_optn, true)
	if optn == nil then
		if _optn:find('Color') then
			optn = 'Black'
		else
			optn = 'Default'
		end
	end
	return optn
end

function CEV:set_visibility_of_van(unit_id, visible)
	if not table.has(CEV.escape_vans, unit_id) then return end
	local van = CEV.escape_vans[unit_id]
	van.unit:set_visibility(Idstring('grp_van'), visible)
	van.unit:set_visibility(Idstring('grp_truck'), visible)
	if van.unit:name() == Idstring('units/payday2/vehicles/str_vehicle_van/str_vehicle_van') then
		van.unit:set_visible(false)
		van.unit:set_enabled(false)
	end
	for index = 0, van.unit:num_bodies() - 1 do
		van.unit:body(index):set_enabled(visible)
	end
	local light_1 = van.unit:get_object(Idstring('lo_omni_1'))
	local light_2 = van.unit:get_object(Idstring('lo_omni_2'))
	if light_1 then light_1:set_enable(visible) end
	if light_2 then light_2:set_enable(visible) end
end

function CEV:set_visibility_of_escape_vehicle(unit_id, visible)
	if not table.has(CEV.escape_vehicles, unit_id) then return end
	CEV.escape_vehicles[unit_id]:set_enabled(visible)
end

function CEV:enable_bodies_of_escape_vehicle(unit_id, enabled)
	if not table.has(CEV.escape_vehicles, unit_id) then return end
	local escape_vehicle = CEV.escape_vehicles[unit_id]
	for index = 0, escape_vehicle:num_bodies() - 1 do
		escape_vehicle:body(index):set_enabled(enabled)
	end
end

function CEV:spawn_escape_vehicle_on_van(unit_id)
	if not table.has(CEV.escape_vans, unit_id) then return end
	if table.has(CEV.escape_vehicles, unit_id) then return end
	local vehicle_name = CEV.vehicle_specs.name
	local vehicle = CEV.vehicle_specs.vehicle
	local van = CEV.escape_vans[unit_id]
	local body = van.unit:body(0)
	local rot = body:rotation() * vehicle.rotation
	local pos = body:position() + (vehicle.position):rotate_with(rot) + Vector3(0,0,-40)
	CEV.escape_vehicles[unit_id] = World:spawn_unit(Idstring(vehicle.path), pos, rot)
	CEV:log('spawned vehicle', unit_id, pos)
	local escape_vehicle = CEV.escape_vehicles[unit_id]
	if escape_vehicle:vehicle_driving() then
		escape_vehicle:vehicle_driving()._tweak_data.name = nil
		escape_vehicle:vehicle_driving()._current_state:disable_interactions()
	end
	if escape_vehicle:damage() then
		local color = CEV.vehicle_specs.color
		if vehicle_name == 'Cadillac' then
			escape_vehicle:damage():run_sequence_simple('state_hide_character')
		end
		if vehicle_name == 'Falcogini' then
			if table.contains(vehicle.colors, color) then
				escape_vehicle:damage():run_sequence_simple('set_color_' .. color)
			end
		end
		if vehicle_name == 'FBI SUV' then
			escape_vehicle:damage():run_sequence_simple('state_interaction_disabled')
		end
		if vehicle_name == 'GenSec Transport' then
			escape_vehicle:damage()._unit_element._sequence_elements['done_opened']._elements = {}
		end
		if vehicle_name == 'Hacker Van' then
			escape_vehicle:damage():run_sequence_simple('state_tier_' .. managers.custom_safehouse:get_room_current_tier('joy'))
		end
		if vehicle_name == 'SUV' then
			escape_vehicle:damage():run_sequence_simple('enable_hitbox2')
			if table.contains(vehicle.colors, color) then
				if color == 'brown' then color = 'white' end
				escape_vehicle:damage():run_sequence_simple('color_' .. color)
			end
		end
		if vehicle_name == 'Truck' then
			if table.contains(vehicle.colors, color) then
				escape_vehicle:damage():run_sequence_simple('var_set_color_' .. color)
			end
		end
	end
end