local houston_workshop = {}

Hooks:PostHook(CustomSafehouseManager, 'load', 'CEV#28900_CustomSafehouseManager_load',
function(self)
	if CEV.Options:GetValue('houston_workshop_tier_4') then
		table.insert(self._global.rooms['american'].unlocked_tiers, 4)
		self._global.rooms['american'].tier_current = 4
	end
end)

Hooks:PreHook(CustomSafehouseManager, 'save', 'CEV#28900_CustomSafehouseManager_save_Pre',
function(self)
	houston_workshop = deep_clone(self._global.rooms['american'])
	table.remove(self._global.rooms['american'].unlocked_tiers, 4)
	self._global.rooms['american'].tier_current = math.min(self._global.rooms['american'].tier_current, 3)
end)

Hooks:PostHook(CustomSafehouseManager, 'save', 'CEV#28900_CustomSafehouseManager_save_Post',
function(self)
	self._global.rooms['american'] = houston_workshop
end)

Hooks:PostHook(CustomSafehouseManager, 'purchase_room_tier', 'CEV#28900_CustomSafehouseManager_purchase_room_tier',
function(self, room_id, tier)
	if room_id == 'american' and tier == 4 then
		CEV.Options:SetValue('houston_workshop_tier_4', true)
		CEV.Options:Save()
		CEV:log('upgraded workshop')
	end
end)