Hooks:PostHook(GameSetup, 'load_packages', 'CEV#28900_GameSetup_load_packages',
function(self)
	local mission_found = nil
	for mission, specs in pairs(CEV.missions) do
		if (Global.game_settings.level_id:find(mission) and not specs.match) or (Global.game_settings.level_id == mission and specs.match) then mission_found = mission end
	end
	for _, mission in ipairs({'skm','arm_for'}) do
		if Global.game_settings.level_id:find(mission) then mission_found = nil end
	end
	if not Global.editor_mode and Network:is_server() and mission_found and CEV.Options:GetValue('houston_workshop_tier_4') then
		CEV.mission_specs = CEV.missions[mission_found]
		if CEV.mission_specs.has_loot then
			CEV.vehicle_specs = {name=CEV:GetOption('EscapeVehicleLoot'),vehicle=CEV.vehicles[CEV:GetOption('EscapeVehicleLoot')],color=CEV:GetOption('EscapeVehicleColor'):lower()}
		else
			CEV.vehicle_specs = {name=CEV:GetOption('EscapeVehicle'),vehicle=CEV.vehicles[CEV:GetOption('EscapeVehicle')],color=CEV:GetOption('EscapeVehicleColor'):lower()}
		end
		local package = nil
		if CEV.vehicle_specs.name == 'Falcogini' and CEV.vehicle_specs.color == 'brown' then
			CEV.vehicle_specs.vehicle.package = 'cev/falcogini_brown'
			CEV.vehicle_specs.vehicle.path = 'units/payday2/vehicles/str_vehicle_car_sport/str_vehicle_car_sport_showroom'
		end
		package = CEV.vehicle_specs.vehicle.package
		if package then
			if not PackageManager:loaded(package) then PackageManager:load(package) end
			CEV:log('loaded package', nil, package)
		else
			CEV._enabled = false
		end
	else
		CEV._enabled = false
	end
	if not CEV._enabled then CEV:log('DISABLED') end
end)