core:module('CoreSequenceManager')

Hooks:PostHook(SequenceElement, 'activate_callback', 'CEV#28900_SequenceElement_activate_callback',
function(self, env)
	local CEV = _G.CEV
	local sequence_name = self._name
	local unit_id =  env.dest_unit:id()
	if CEV and CEV._enabled and CEV.escape_vans and table.has(CEV.escape_vans, unit_id) and sequence_name then
		local van = CEV.escape_vans[unit_id]
		local vehicle = CEV.vehicle_specs.vehicle
		CEV:log('ran sequence', unit_id, sequence_name)
		if sequence_name == 'state_show' or sequence_name == 'state_vis_show' then
			if CEV.mission_specs.has_equip then
				CEV:set_visibility_of_van(unit_id, true)
				CEV:set_visibility_of_escape_vehicle(unit_id, false)
			else
				CEV:set_visibility_of_van(unit_id, false)
				CEV:set_visibility_of_escape_vehicle(unit_id, true)
			end
			van.data.state_synched = true
		end
		if sequence_name == 'state_hide' or sequence_name == 'state_vis_hide' then
			CEV:set_visibility_of_van(unit_id, false)
			CEV:set_visibility_of_escape_vehicle(unit_id, false)
		end
		if CEV.escape_vehicles and table.has(CEV.escape_vehicles, unit_id) then
			local escape_vehicle = CEV.escape_vehicles[unit_id]
			for _, anim in ipairs({'arrive','leave','enter','exit','intro','crash','road'}) do
				if sequence_name:find(anim) and not van.data.anim_running then
					van.data.anim_running = true
					CEV:set_visibility_of_escape_vehicle(unit_id, true)
					CEV:enable_bodies_of_escape_vehicle(unit_id, false)
				end
			end
			if sequence_name:find('done') then
				CEV.escape_vans[unit_id].data.anim_running = false
				CEV:enable_bodies_of_escape_vehicle(unit_id, true)
				CEV:log('finished anim', unit_id, sequence_name)
			end
			if escape_vehicle:damage() then
				local anim_list = {}
				for _, anims in pairs(CEV.sequences) do
					if anims.source and table.contains(anims.source, sequence_name) then
						anim_list = anims.custom
					end
				end
				if sequence_name:find('bag') then
					local seq = CEV.sequences['van_loot_added'][sequence_name]
					if escape_vehicle:damage():has_sequence(seq) then
						escape_vehicle:damage():run_sequence_simple(seq)
						van.data.last_seq = seq
					end
				end
				for _, anim in ipairs(anim_list) do
					local seq = vehicle.anims and vehicle.anims[anim]
					if escape_vehicle:damage():has_sequence(seq) and van.data.last_seq ~= seq then
						escape_vehicle:damage():run_sequence_simple(seq)
						van.data.last_seq = seq
					end
				end
			end
		end
	end
end)